# My first paper in 10 years?!

Published: 2019-04-03.

It's been nearly two months since my last day at Google, so I guess I should finally make use of this newsletter :)

I wrote [a paper](https://docs.google.com/document/d/1ZGGNMfmfpWB-DzWS3Jr-YLcRNRjhp3FKS6v0KELxXK8/preview) which was published on April 1st as part of SIGBOVIK 2019: "93% of Paint Splatters are Valid Perl Programs". In this paper, I answer a long-standing open problem in the programming languages community: *is it possible to smear paint on the wall without creating valid Perl?*

(Long-standing since February 13, 2019, when a [Twitter conversation](https://twitter.com/jaffathecake/status/1095706032448393217) between Adrienne Porter Felt & Jake Archibald posed the question.)

To answer this question, I downloaded 100 images of paint splatters from Pinterest, ran the open-source Tesseract OCR engine to turn each into a text string, and then sent that text to the Perl interpreter to see whether that text successfully parsed as Perl. It turns out that 93 of the 100 paint splatters do parse as valid Perl, but since 7% do not, I conclude that it **is possible** to smear paint on a wall without creating valid Perl.

You might suspect there is some chicanery going on with this result. You'd be correct, but... honestly there's not *that* much chicanery going on. You'll have to read the paper for details... and for my attempts at academic humor. :)

There's also some [supporting material](/sigbovik) on this website, including a [gallery of all 100 images](/sigbovik/splatters.html) and their associated valid Perl code. Here's a screenshot of some of them. (Did you know that the string `lerzfijglpFiji-j` evaluates to the number `0` in Perl?)

![screenshot of 17 paint splatters, and the Perl programs they represent](https://gallery.tinyletterapp.com/76b879b0e95d11cda4d7d21283ce7d32a4f76e09/images/63d8cc7b-9d70-493c-9f64-1aa7da5b9426.png)

As it turns out, the publication date of my paper was exactly 10-years-minus-a-day since my Ph.D. thesis defense. I'd planned on travelling back to Carnegie Mellon to give this talk live at SIGBOVIK 2019, but unfortunately came down with a nasty cold-and-cough so I had to cancel my trip. :( Perhaps I can give a belated talk at next year's conference.

For more light-hearted and vaguely CS-shaped research papers, check out the rest of the [SIGBOVIK 2019 proceedings](http://sigbovik.org/2019/proceedings.pdf). I particularly enjoyed "Elo World, a framework for benchmarking weak chess engines" by tom7 ("The computer players include some traditional chess engines, but also many algorithms chosen for their simplicity, as well as some designed to be competitively bad".)

Some other random things that I've been up to in the last month-and-a-half:

  * [ohnosay](https://twitter.com/mcmillen/status/1095795492196364297), which is like "cowsay" but for comics in the style of webcomicname. [GitHub] This was a good excuse to get a Linux development environment set up on a persistent Google Cloud instance & to learn how to GitHub. Since then, I also realized that the World Outside Google uses Python 3, so I've started learning that :)

    ![a three panel comic displayed on a linux terminal: "i will write a silly program" "hm, what did i do with my ssh credentials?" "oh no"](https://gallery.tinyletterapp.com/76b879b0e95d11cda4d7d21283ce7d32a4f76e09/images/e5032bd6-fe2c-4d1a-a023-3598e144c9c2.png)

  * Gardening! Last August I randomly planted some peppermint in a railing container on my balcony, and it went gangbusters. This spring I've actually planned out a whole porch-garden (like [Stardew Valley but real life](https://twitter.com/sevandyk/status/1109121188079427585)). Last year's mint has started growing again, and I've added spearmint and mojito mint. I've also got two types of peas, two mixes of salad greens, and spinach planted. Later I'll be planting carrots, basil, and rosemary. The peas just started sprouting a couple days ago, which is exciting!

    ![a container showing an assortment of "asian salad" greens](https://gallery.tinyletterapp.com/76b879b0e95d11cda4d7d21283ce7d32a4f76e09/images/4e7e993c-8f90-4117-ad36-bb32a20a78c5.jpg)

  * Gloomhaven! This is a cooperative legacy-style board game -- a fun dungeon-crawler that doesn't need a DM, so everyone gets to play. Our group is still only a few scenarios in, but we're enjoying it so far. SO MANY HEX TILES. I'm also getting ready to paint our party's miniatures, which is another (potential) new hobby of mine; more to come in a future newsletter, I suspect :)

  * Video games: just started Sekiro: Shadows Die Twice on PS4. Recently completed (and really enjoyed) New Super Mario Bros. U Deluxe for Nintendo Switch (though Nintendo seems to be trying to give Google a run for their money on ridiculous product names). I've also been playing Total War: Warhammer 2 regularly, and Splatoon 2 from time to time. I tried getting into XCOM 2 & enjoyed it, but I'm not sure I'm interested enough to finish the campaign. I keep going back to Total War when I want something in the tactical / strategy genre.

  * Guitar: starting to learn fingerstyle, with the goal of eventually becoming good enough to play [Dream of the Shore Bordering Another World](https://www.songsterr.com/a/wsa/chrono-cross-dream-of-the-shore-boardering-another-world-tab-s5033t2) from Chrono Cross.

  * Computer stuff: upgraded my PC's video card (it was many years old) and upgraded to an all-SSD setup. It turns out that 2TB SSDs aren't that expensive any more.

  * Getting healthcare without an employer is a disaster --- even in Massachusetts, which reportedly has one of the best systems in the US. Still working on straightening out my paperwork. Apparently they refuse to believe in my proof of health-insurance termination, even though it's lettermarked by Google and everything.

Thanks for reading! Hopefully the next update will come sooner than 2 months and thus be a bit shorter than this one ended up being :)

~ Colin
